flex: Disable LTO in the libfl.a for clang.
[dragonfly.git] / UPDATING
CommitLineData
d2a0decc
MD
1# Updating Information for DragonFly users.
2#
3#
4# This file should warn you of any pitfalls which you might need to work around
5# when trying to update your DragonFly system. The information below is
6# in reverse-time order, with the latest information at the top.
7#
8# If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9# mailing list with the details.
d2a0decc 10
3522bdfe
SW
11+-----------------------------------------------------------------------+
12+ UPGRADING DRAGONFLY FROM 4.6 TO LATER VERSIONS +
13+-----------------------------------------------------------------------+
14
d6e8ab2d
SW
15COMPAT_43 KERNEL OPTION REMOVED
16-------------------------------
17
18It was commented out in our default configs for several years now, but
19might still be present in custom configs created before Nov. 2011.
20
adfb2c71
JM
21OPENSSL REMOVED
22---------------
23
24OpenSSL has been removed from base and replaced with a private version of
25LibreSSL. The previously installed OpenSSL libraries, headers, and man
26pages will remain on the system unless the "make upgrade" command is
27specifically instructed to remove them. To do this, define
28REMOVE_OPENSSL_FILES for the upgrade command, e.g.
29"make upgrade REMOVE_OPENSSL_FILES=yes"
30
5b245968
MD
3128-Oct-2016: openssl has been replaced by ressl. It is recommended that any
32stale OpenSSL files be removed to avoid configuration scripts from using
33the stale and potentially vulnerable version, but all binaries that are
34dynamically linked to the OpenSSL libraries should be rebuilt first to
35avoid breakage.
adfb2c71 36
859c2e53
SW
37CS, EX AND VX DRIVERS REMOVED
38-----------------------------
3522bdfe 39
859c2e53
SW
40The cs(4), ex(4) and vx(4) drivers have been removed. They were very
41old and its doubtful they ever worked properly in x86_64 but they were
42in X86_64_GENERIC, so custom configurations derived from it have to be
3a609f3d 43adjusted.
3522bdfe 44
82aec1d3
FT
45+-----------------------------------------------------------------------+
46+ UPGRADING DRAGONFLY FROM 4.4 TO LATER VERSIONS +
47+-----------------------------------------------------------------------+
48
f1826c3e
SW
49AMD REMOVED
50-----------
51
52The am-utils automounter suite has been removed. It stopped working
53at some point and was never fixed. autofs(5) and the associated
54userland has been brought in from FreeBSD and replaces it.
55
c222305f
SW
56AN DRIVER REMOVED
57-----------------
82aec1d3 58
c222305f
SW
59The an(4) driver has been removed. It was in the X86_64_GENERIC kernel
60config file, so any configurations derived from it have to be adjusted.
82aec1d3 61
c222305f
SW
62/DEV/DRI GROUP CHANGED
63----------------------
64
65The default group assigned to /dev/dri entries has been changed
66from 'wheel' to 'video' with the id of '44'. If you want to have
67access to the dri devices please add yourself to the video group
68with:
69
70# pw groupmod video -m $USER
82aec1d3 71
dbf3d3ba
JM
72+-----------------------------------------------------------------------+
73+ UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS +
74+-----------------------------------------------------------------------+
75
54af9d02
SW
76DSCHED REMOVED
77--------------
78
79dsched(4) has been removed and one of its kernel options, DSCHED_FQ, was
80in our default kernel config file. So the DSCHED_FQ option has been turned
81into a no-op for now and can be removed from custom configurations.
82
68ef81ed
SW
83EST DRIVER REMOVED, COMPILE_ET AND LIBCOM_ERR TOO
84-------------------------------------------------
85
86The est(4) driver has been removed. All CPUs it supported (except one)
87were 32 bits only. Those who are still using the Core 2 Duo T7500 should
88report back if there are any issues with this CPU and our regular ACPI
89P-state support.
90
91Also, compile_et(1) and com_err(3) have been removed as well. They
92should have been removed along with kerberos support, back in 2009.
93
dbf3d3ba
JM
94SEVERAL LOCALES RENAMED
95-----------------------
96
97Several locales were using obsolete and misleading names, and thus have
98been adjusted to current standards. Any users of the following locales
99need to select alternates:
100
101DFLY 4.2 locale DFLY 4.4 alterative locale
102--------------- ------------------------------------
103mn_MN.UTF-8 mn_Cyrl_MN.UTF-8
104no_NO.UTF-8 nb_NO.UTF-8 or nn_NO.UTF-8
105no_NO.ISO8859-1 nb_NO.ISO8869-1 or nn_NO.ISO8859-1
106no_NO.ISO8859-15 nb_NO.ISO8859-15 or nn_NO.ISO8859-15
107sr_YU.UTF-8 sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
108sr_YU.ISO8859-5 sr_Cyrl_RS.ISO8859-5
109sr_YU.ISO8859-2 sr_Latn_RS.ISO8859-2
110zh_CN.GBK zh_Hans_CN.GBK
111zh_CN.UTF-8 zh_Hans_CN.UTF-8
112zh_CN.eucCN zh_Hans_CN.eucCN
113zh_CN.GB2312 zh_Hans_CH.GB2312
114zh_CN.GB18030 zh_Hans_CH.GB18030
115zh_HK.Big5HKSCS zh_Hant_HK.Big5HKSCS
116zh_HK.UTF_8 zh_Hant_HK.UTF-8
117zh_TW.Big5 zh_Hant_TW.Big5
118zh_TW.UTF-8 zh_Hant_TW.UTF-8
119
2a617999
SW
120+-----------------------------------------------------------------------+
121+ UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS +
122+-----------------------------------------------------------------------+
123
65c3b857
JM
124BINUTILS 2.25 REPLACES 2.22, PRIMARY
125------------------------------------
126
127The oldest of the two versions of Binutils, version 2.22, was removed
128and replaced with Binutils 2.25. It becomes the primary version version
129of binutils and version 2.24 becomes the alternate. There are 8 current
130CVE written against 2.24, so for security reasons version 2.25 should
131always be used.
132
133The accepted values of BINUTILSVER are now "binutils225" (default) and
134"binutils224". The building of Binutils 2.24 can be prevented by setting
135NO_ALTBINUTILS=yes in make.conf.
136
72b78560
JM
137LOADER OPTIONS CHANGED
138----------------------
139
140Right after the development branch started, the Fred art accompanying the
141loader menu was improved. The line between Fred and the menu was removed
142by default (but can optionally be returned) and the placement shifted as
143a result. The drawing was improved, and the colored version was improved,
144changing the eyes and wing color from white to red. A new color version
145of Fred was added, one with a blue scheme.
146
147The loader menu defaults have changed since release 4.0: The vertical
148line was removed, the loader is displayed in color by default*, and the
149blue scheme is used.
150
151The loader.conf changes are:
152loader_color: option has been removed
153loader_plain: option has been added, it changed menu to monochrome
154fred_is_red: changes color scheme from blue to red
155fred_is_blue: option existed only on 4.1, it has been removed
156fred_separated: Adds line between Fred and menu (as seen previously)
157
158* If loader.conf defines "console" as "comconsole" or "console" is defined
159 in the environment as "comconsole" then color will not be displayed,
160 even if loader_plain value is "NO".
161
cbab4ab1
JM
162SENDMAIL REMOVED FROM BASE
163--------------------------
164
165The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
166If the system being upgraded is still configured to use the sendmail
167binaries from base, the "make upgrade" command will fail.
168
169The administrator must change /etc/mail/mailer.conf to switch the
170mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
171command that permanently removes sendmail executables and could
172potentially break a running mail server.
173
174Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
175detailed instructions on how to configure the MTA selection.
176
a7ac1ee9
SW
177_KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
178--------------------------------------------
179
180The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
181no-ops. They can be removed from custom kernel configurations.
182
aa7c3d6b
FT
183SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
184--------------------------------------------
185
186Many more sound devices may be detected.
187
188If the default device choosen isn't to your liking, setting the sysctl
189hw.snd.default_unit to a different number will change it.
190
60a260ad
SW
191SCTP SUPPORT DROPPED
192--------------------
193
194Support for the SCTP protocol has been removed.
195
2a617999
SW
196OLD USB DRIVERS REMOVED
197-----------------------
198
199The old USB stack, along with the kernel config option "device oldusb"
200and the make.conf variable "WANT_OLDUSB" have been removed. This means
201that for custom kernel configuration files which were derived from a
202GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
203various (old USB stack specific) devices will now complain about being
204unknown:
205
206 * oldusb (obviously)
207 * natausb (not yet ported to usb4bsd)
208 * rue (not yet ported to usb4bsd)
209 * ugen (no longer needed in usb4bsd)
210 * urio (not yet ported to usb4bsd)
211 * uscanner (no longer needed in usb4bsd)
212
213They should be removed or commented out in such custom kernel configs.
214
4e8e707f
JM
215GCC 5
216-----
217
218The GCC 4.4 compiler has been retired. It has been replaced by a GCC 5.1.
219The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
220NO_CXX. The latter was never documented and the latest versions of GCC are
221partially written in C++ so a C++ compiler is no longer optional. In
222practical terms it has not been optional for many years as other base
223components are also written in C++. The resource savings by avoiding
224building Objective-C compiler is so small, the complexity added by NO_OBJC
225internally was deemed a bad tradeoff so that is the reason for its removal.
226Also note that no "info" pages are installed with GCC 5. After this entry
227was originally written, all info pages were removed from DragonFly.
228
229GCC 5.1 has been designated as the primary compiler. As such, there is a
230new make.conf variable, NO_ALTCOMPILER. It will block the rebuilding of
231the designated secondary compiler, GCC 4.7. However, while DPorts
232primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
233if building ports from source is desired, don't block building of the
234secondary compiler.
e9b676f1 235
0055c35b
SW
236+-----------------------------------------------------------------------+
237+ UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS +
238+-----------------------------------------------------------------------+
239
2a617999 240SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
39b3e0a1
SW
241-------------------------------------------
242
243DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
244the default now (even on single-core systems), both for, like, 21 months.
245We kept the options around as no-ops as a convenience, to allow people
246using the same config for the then current release and the then current
247master. That period is now over, so any configs still having those
248options have to be adjusted.
249
10ceb702
SW
250SYSVIPC SYSCALLS MADE NON-OPTIONAL
251----------------------------------
252
253The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
254now compiled in by default. The options are no-ops for now.
255
79a3e83f
SW
256DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
257--------------------------------------------------------------------
258
259The default driver for those controllers is now mrsas(4) due to reports
260of file system corruption using the mfi(4) driver. The whole issue (and
261how to deal with potential problems when switching) was explained here:
262
263http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
264
265A tunable is provided for letting those controllers still attach via
266the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
267
0055c35b
SW
268OLDER NETWORK DRIVERS MOVED TO I386 ONLY
269----------------------------------------
270
271The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
272and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
273removed in kernel configs derived from X86_64_GENERIC.
274
e19e3c77 275+-----------------------------------------------------------------------+
62d4130d 276+ UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS +
e19e3c77
SW
277+-----------------------------------------------------------------------+
278
a6a7c140
JS
279UPDATE FROM MOST RECENT 3.6
280---------------------------
281
282Versions of 3.6 built before June 25th have a bug where installworld might
283crash during installation of the new initrd. Upgrade to the latest version
284of 3.6 before updating to 3.8 or later.
285
7c87aae6
SW
286ATM, IPX, NCP AND NWFS SUPPORT DROPPED
287--------------------------------------
6f25d555
SW
288
289Support for the IPX and NCP network protocols and for mouting NetWare
7c87aae6 290file systems has been dropped. Dito for ATM protocol support.
6f25d555
SW
291
292INITRD IMAGES NOW INSTALLED BY DEFAULT
293--------------------------------------
294
295An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
296
297Older images installed under the file name of initrd.img will be removed
298automatically by the make upgrade process.
299
f0478b8b
SW
300USB4BSD IS NOW THE DEFAULT USB STACK
301------------------------------------
302
303To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
304replace "device usb" with "device oldusb" in the kernel configuration.
305
e19e3c77
SW
306MORE ISA SUPPORT DROPPED
307------------------------
308
309ISA support has been dropped from the following drivers: adv(4), an(4),
310ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
311si(4), sn(4), and stg(4).
312
9332798a 313+-----------------------------------------------------------------------+
62d4130d 314+ UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS +
9332798a
SW
315+-----------------------------------------------------------------------+
316
c04df145
JS
317ABI CHANGE
318----------
319
320Installed third-party software (dports) will have to be rebuilt after upgrade,
321or reinstalled from binary packages.
322
2b455b95
JS
323UPDATING FROM 3.4 TO 3.6
324------------------------
325
326This only applies for this specific upgrade due to locale changes; it is
327not needed for upgrades after 3.6. Please update in this order:
328
329make buildworld
330make buildkernel
331make installworld
332make installkernel
333*reboot*
334make upgrade
335
336See this mailing list post for details:
337http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
338
9332798a
SW
339CYRIX OPTIONS REMOVED
340---------------------
341
342The following Cyrix related options have been removed: CPU_BTB_EN,
343CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
344CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
345CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
346
347ISA SUPPORT REMOVED FROM RP(4)
348------------------------------
349
350ISA support has been removed from the rp(4) driver. It is now PCI only.
351
64aeb497 352+-----------------------------------------------------------------------+
62d4130d 353+ UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS +
64aeb497
SW
354+-----------------------------------------------------------------------+
355
d88b9605
SW
356COMPAT_SUNOS OPTION REMOVED
357---------------------------
358
359The COMPAT_SUNOS option has been removed. It was meant to provide binary
360compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
361
43f215d7
SW
362ISA SOUND CARD SUPPORT REMOVED
363------------------------------
364
365The following modules have been removed (all for ISA sound cards):
366snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
367
6100d1de
JM
368GCC 4.7
369-------
370
371DragonFly has switched base compilers. GCC 4.7 is now the default
372compiler and GCC 4.4 is the alternative compiler. The "NO_GCC47" make
373variable ceases to work now.
374
375Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
376/etc/make.conf to prohibit GCC 4.4 from building. However, using it is
377highly discouraged. There are a few packages in pkgsrc that do not build
378with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default. At
379this time, it is recommended to keep both compilers on the base system.
380
2089bb7c
SW
381SMP OPTION REMOVED
382------------------
383
384The SMP kernel option has been made a no-op. All kernels now feature SMP
385support. If you have 'options SMP' in your kernel config, you can as well
386remove it.
387
1c297ed0
SW
388DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
389---------------------------------------------------------------------------
640dc18f
SZ
390
391The DEVICE_POLLING kernel option has been made a no-op and it has been
392replaced by IFPOLL_ENABLE. If you have 'options DEVICE_POLLING' in your
393kernel config, you need to change it to IFPOLL_ENABLE.
394
1c297ed0
SW
395Also, the KTR_POLLING kernel option has been removed, so it must be
396removed from kernel configs that have it.
397
558b0a0b
SW
398BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
399---------------------------------------------------
850c4634
SW
400
401The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
402cards will no longer be detected.
403
e6f626a1
SW
404The same has been done for Stallion multiport serial controllers. stli(4)
405has been completely removed (along with the stlload(8) and stlstty(8)
558b0a0b
SW
406utilities) and stl(4) was changed to support only PCI cards. Similarly,
407ISA support was removed from cy(4) too. All these drivers are i386 only.
e6f626a1 408
e98bcb27
SW
409COMPAT_OLDISA OPTION GONE
410-------------------------
411
412The i386 specific COMPAT_OLDISA kernel option has been removed, since
413nothing needs it anymore.
414
c691bb43 415+-----------------------------------------------------------------------+
62d4130d 416+ UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS +
c691bb43
SW
417+-----------------------------------------------------------------------+
418
419APIC_IO OPTION REMOVED
420----------------------
421
422The APIC_IO kernel option is no longer accepted after having been without
423effect for a while. The hw.ioapic_enable tunable now serves its purpose.
424If you have 'options APIC_IO' in your kernel config, you'll have to
425remove it.
426
6d488cc3
SW
427WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
428-----------------------------------------
cf03d6cd
SW
429
430The wdog framework is now compiled into our kernels by default, so the
6d488cc3 431options are no longer needed.
cf03d6cd 432
397ffc5c
SW
433DOSCMD(1) REMOVED
434-----------------
435
436doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
437NO_X make.conf option was removed too.
438
a1404d4f
SW
439GCC 4.7
440-------
441
442GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
443default compiler in base (default is still GCC 4.4).
444
445Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
446NO_GCC47 in /etc/make.conf.
447
2508820f
SW
448USB4BSD
449-------
450
451A new USB stack (from FreeBSD) has been brought in. The following
452modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
453usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
454and uaudio.
455
456It is not yet the default. To activate it, WANT_USB4BSD=yes has to
c7200221
SW
457be put in make.conf and device "usb4bsd" (quotes needed) has to
458replace device usb in the kernel config. After that, a full
459build/install/upgrade cycle is needed.
2508820f
SW
460
461Note that this is experimental and incomplete, but we are interested
462in hearing about issues with it, of course.
463
ae0870a3
SW
464ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
465---------------------------------------------
466
467ISA adapter support was dropped from the aic(4) driver.
468
96386d4b 469+-----------------------------------------------------------------------+
62d4130d 470+ UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS +
96386d4b
SW
471+-----------------------------------------------------------------------+
472
473SEVERAL ISA DRIVERS REMOVED
474---------------------------
475
476The following ISA only drivers have been removed along with a couple of
477associated userland tools:
478
479aha(4)
480asc(4) & sasc(1)
481ctx
482dgb(4)
483el(4)
484gpib
485gsc(4) & sgsc(1)
486ie(4)
487labpc(4)
488le(4)
489mse(4)
490rc(4)
491rdp(4)
492spigot
493tw(4) & xten(1) & xtend(8)
494wl(4) & wlconfig(8)
495wt(4)
496
497Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
498config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
499file.
500
501If buildkernel complains about any of these drivers, just remove them
502from your kernel configuration.
503
919eb219
JM
504BINUTILS 2.20
505-------------
37c5a0db 506Binutils 2.20 has been removed in favor of Binutils 2.22. The accepted
e685772e 507values of BINUTILSVERS are now binutils221 and binutils222 (default).
919eb219 508
83bc1e2a
SW
509BUILDWORLD/-KERNEL PARALLELIZATION WORK
510---------------------------------------
511Due to changes in the way we build with more than one make job, you
512will have to update install(1) and mkdir(1) prior to buildworld if you
513want to build with 'make -j':
514
515cd /usr/src/usr.bin/xinstall; make; make install; make clean
516cd /usr/src/bin/mkdir; make; make install; make clean
517
eca86bd9
SW
518DMA(8) UPGRADE
519--------------
520dma(8) has been upgraded to v0.7 which no longer supports the
521/etc/dma/virtusertable. Some of its functionality has been replaced
522with the MASQUERADE keyword and the EMAIL environment variable (see
523the dma(8) manual page).
524
a4a39c94 525+-----------------------------------------------------------------------+
62d4130d 526+ UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS +
a4a39c94
JS
527+-----------------------------------------------------------------------+
528
b1242318
SW
529GCC 4.4 & BINUTILS 2.21
530-----------------------
30c91f0c 531
b1242318
SW
532GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
533been made DragonFly's default Binutils.
30c91f0c
SW
534
535That means that any settings that set CCVER to 'gcc44' are not needed
536anymore. Instead, CCVER can be set to 'gcc41' to go back to using
537GCC 4.1.
538
b1242318
SW
539It also means that 'binutils221' as a value for BINUTILSVER has no
540effect anymore. 2.17 has been removed and 'binutils220' is available
541as an option.
542
5738210d 543The NO_GCC44 option has been removed and will not affect the build
30c91f0c
SW
544anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
545building in a similar fashion.
546
80abb3be 547Note that you must do a full buildworld/buildkernel for upgrading.
30c91f0c 548
a4a39c94 549pkg_radd settings
c983d16e 550-----------------
a4a39c94
JS
551
552The config file for pkg_radd has moved from /etc/settings.conf to
553/etc/pkg_radd.conf. Save the contents of settings.conf before upgrading
554if this is needed. This warning only applies if /etc/settings.conf
555exists. pkg_radd will continue to work with defaults.
556
b79f66dd 557+-----------------------------------------------------------------------+
72fe41d3 558+ 20100927 +
1bb1cc14 559+ UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD +
b79f66dd
JT
560+-----------------------------------------------------------------------+
561
72fe41d3 562OpenSSL
c983d16e 563--------
72fe41d3
PA
564
565OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
566This shouldn't break any 3rd-party software, but you'll need to recompile your
5673rd-party software if you want it to link against the new version of OpenSSL.
568
8eb0b612 569Loader
c983d16e 570-------
8eb0b612 571
b79f66dd
JT
572A new loader (dloader) has been added which better handles booting from
573multiple kernel/module versions.
574
575To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
576
577 cd /usr/src
578 make buildworld
579 make installworld
580 make upgrade
581 make buildkernel KERNCONF=<KERNELNAME>
582 make installkernel KERNCONF=<KERNELNAME>
583
584Note that you must installworld and run the 'upgrade' target before
585installing the new kernel.
586
8eb0b612 587BIND
c983d16e 588-----
8eb0b612
JS
589
590BIND has been removed from the base system. The ldns and drill tools have
591been added for basic functionality. Use 'drill' where you would normally
592use nslookup or dig, or install BIND from pkgsrc. It's available as
593net/bind95, net/bind96, or net/bind97 as of this writing.
594
595This only affects older systems upgrading to 2.8. New 2.8+ installs
596include BIND as a pkgsrc package.
597
d2a0decc
MD
598+-----------------------------------------------------------------------+
599+ UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM +
600+ GENERAL +
601+-----------------------------------------------------------------------+
984263bc 602
a700883c
SW
603Instructions on how to obtain and maintain DragonFly source code using git
604are in the development(7) manual page.
d2a0decc
MD
605
606To upgrade a DragonFly system from sources you run the following sequence:
607
608 cd /usr/src
609 make buildworld
610 make buildkernel KERNCONF=<KERNELNAME>
611 make installkernel KERNCONF=<KERNELNAME>
612 make installworld
613
614You will also want to run the 'upgrade' target to upgrade your /etc and the
615rest of your system. The upgrade target is aware of stale files created by
616older DragonFly installations and should delete them automatically.
617
618 make upgrade
619
a700883c
SW
620See the build(7) manual page for further information.
621
d2a0decc
MD
622Once you've done a full build of the world and kernel you can do incremental
623upgrades of either by using the 'quickworld' and 'quickkernel' targets
624instead of 'buildworld' and 'buildkernel'. If you have any problems with
a700883c 625the quick targets, try updating your repo first, and then a full buildworld
d2a0decc 626and buildkernel as shown above, before asking for help.
4523a2c0
TN
627
628+-----------------------------------------------------------------------+
629+ UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1 +
630+-----------------------------------------------------------------------+
631
632In 2.1 kernel and modules has moved to boot directory. For most cases
633this is handled automatically by 'make upgrade'. A few cases needs manual
634intervention:
635
636 * When installing a kernel without first doing a make buildworld,
637 installworld and upgrade to the same DESTDIR as kernel:
638 make DESTDIR/boot directory and move kernel and modules into this boot
639 directory; also move kernel.old and modules.old.
640 Typical example is vkernel(7), use (no modules used):
641
642 cd /var/vkernel
643 mkdir boot
644 chflags noschg kernel
645 mv kernel kernel.old boot
646 chflags schg boot/kernel
647
648 * When using a boot-only partition, /boot/loader.rc needs to be edited:
649 delete occurrences of '/boot/'.
650 These occurences can normally be deleted in any case, see loader(8).
d2a0decc
MD
651
652+-----------------------------------------------------------------------+
653+ UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9 +
654+-----------------------------------------------------------------------+
655
656In 1.9 major changes to the disk management infrastructure have taken
657place. make upgrade may not catch all of your disk devices in /dev,
658so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
45e80934
MD
659are all of your disk devices. HOWEVER, from late 2.3 on we run devfs
660and MAKEDEV no longer exists.
d2a0decc
MD
661
662The biggest changes in 1.9 are:
663
664(1) That whole-slice devices such as da0s1 no longer share the same device
665 id as partition c devices such as da0s1c.
666
667(2) The whole-disk device (e.g. da0) is full raw access to the disk,
668 with no snooping or reserved sectors. Consequently you cannot run
669 disklabel on this device. Instead you must run disklabel on a
670 whole-slice device.
671
672(3) The 'compatibility' partitions now use slice 0 in the device name,
673 so instead of da0a you must specify da0s0a. Also, as per (1) above,
674 accessing the disklabel for the compatibility partitions must be
675 done via slice 0 (da0s0).
676
677(4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
678 and CCD now run through the disk management layer and are assigned
679 real disk management devices. VN and CCD in particular do not usually
680 use a MBR and disklabels must be accessed through the compatibility
681 slice 0. Your /etc/ccd.conf file still specifies 'ccd0', though, you
682 don't name it 'ccd0s0' in the config file.
683
684Generally speaking, you have to get used to running fdisk and disklabel on
685the correctly specified device names. A lot of the wiggle, such as running
686disklabel on a partition, has been removed.
687
688+-----------------------------------------------------------------------+
689+ UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD +
690+-----------------------------------------------------------------------+
691
692> Kerberos IV
693-------------
694
695Kerberos IV (eBones) was removed from the tree, please consider moving to
696Kerberos 5 (Heimdal).
697
698> Package Management System
699---------------------------
700
701Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
702management system. The necessary tools to build and maintain packages
703are provided in /usr/pkg/bin and /usr/pkg/sbin. Make sure that these
704directories are in your PATH variable.
705
706In order to obtain a reasonably current snapshot of the pkgsrc tree, use
707the tarball from NetBSD:
708
709 fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
710 cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
711
712This tree can then be kept up to date with cvs update:
713
714 cd /usr/pkgsrc; cvs up
715
716NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
717build and install the pkgsrc bootstrap manually:
718
719 cd /usr/pkgsrc/bootstrap
720 ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
721
722+-----------------------------------------------------------------------+
723+ UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM +
724+ UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO +
725+ DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD) +
726+-----------------------------------------------------------------------+
58116288 727
114580ac 728The compatibility shims for the build environment have been removed, you
58116288
JS
729have to update to DragonFly 1.2 release branch first.
730
1fcc7462
JS
731The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
732The existing configuration can be converted using /etc/pam.d/convert.sh.
733Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
734the pam_skey.so module was retired, you have to remove it manually from
735your configuration, when you convert it.
58116288 736
a3107071
MD
737> Required user and group IDs when upgrading from either FreeBSD or DragonFly
738---------------------
739
740The following users may be missing from your password file. Use vipw and
741add any that are missing:
742
743smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
dcf85892 744_pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
a3107071
MD
745
746The following groups may be missing from your group file. Use vi /etc/group
747and add any that are missing:
748
749smmsp:*:25:
750authpf:*:63:
dcf85892 751_pflogd:*:64:
a3107071
MD
752
753
f419daca 754> Upgrading to DragonFly from FreeBSD
5e0ae0d4 755---------------------
984263bc 756
f419daca
MD
757You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
758FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
759FreeBSD. Note that the DragonFly buildworld target does not try to reuse
760make depend information, it starts from scratch, so no pre-cleaning of the
761object hierarchy is necessary.
762
466bbc10 763 # get the CVS repository (it is placed in /home/dcvs, 500MB).
f419daca
MD
764 # Please use the -h option and a mirror site to pull the
765 # initial repository, but feel free to use the main repository
766 # machine to pull updates.
5010eeb3 767 cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
f419daca
MD
768 # install the source from the CVS hierarchy (remove preexisting
769 # FreeBSD src first) (500MB)
770 cd /usr
771 rm -rf src
50172b1c 772 cvs -R -d /home/dcvs checkout -P src
f419daca
MD
773
774 # build it (500MB used in /usr/obj)
775 #
776 cd /usr/src
777 make buildworld
778 make buildkernel KERNCONF=<KERNELNAME>
984263bc 779
f419daca
MD
780Once you have built DragonFly you have to install it over FreeBSD. Since
781DragonFly does not track changes made by FreeBSD to its include file
782hierarchy and include file pollution can cause all sorts of unexpected
783compilation issues to come up, it is best to wipe your include hierarchy
784prior to installing DragonFly. Note that you should not wipe any installed
785FreeBSD header files or binaries until after you have successfully completed
786the build steps above.
fb12f484 787
f419daca
MD
788 rm -rf /usr/include
789 mkdir /usr/include
790 make installkernel KERNCONF=<KERNELNAME>
791 make installworld
fb12f484 792
b8cbf045 793Then you need to upgrade your system. DragonFly's 'make upgrade' target
f419daca 794will unconditionally upgrade the /etc files that sysops do not usually
b8cbf045
SW
795mess around with, such as the files in /etc/rc.d. It will also remove any
796obsolete files such as utilities and manpages that have been removed from
797the system since the version you're coming from. If you are unsure we
798recommend that you make a backup of at least your /etc before applying
799this step. Note that DragonFly's RC system is basically RCNG from
800FreeBSD-5, but there are some differences in the contents of the RC files.
f419daca
MD
801
802 make upgrade
803
b8cbf045
SW
804NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
805Doing so might leave your system in an unusable state.
806
f419daca 807Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
b8cbf045
SW
808/usr/bin, and /usr/lib, and remove any stale files that you find. Please
809report these files to the DragonFly developers so that they can be added to
810the 'upgrade' target.
f419daca 811